"""
A quick skript "Deobfuskator" written in Python by Catador,
do whatever you want with this code. Really.

This was tested only on a single script, using Python 3.6,
but should PROBABLY work on other scripts and on older Python 3 versions

This is not compatible with Python 2, it would need slight modifications
"""

import re


def run():
    sk_file  = None
    out_file = None
    fname    = None
    try:
        fname = input('Enter the filename for the obfuscated skript: ')
        sk_file  = open(fname, 'r')
    except FileNotFoundError:
        return print("The file \"{0}\" doesn't exist! Exiting...".format(fname))
    out_file = open('deobf_'+fname, 'w')

    dictionary = {}
    file_offset = 0 # file.tell() doesn't work inside a for loop like the following, so I just keep adding the line length to a variable
    reading_options = False
    for line in sk_file:
        if line.startswith('options:') and not reading_options:
            file_offset += len(line)+1
            reading_options = True
        elif (line.startswith(' ') or line.startswith('\t')) and not line.startswith('#'): # Read an option and add it to the dictionary
            file_offset += len(line)+1
            line = line.lstrip()
            i = line.find(':')
            option = line[:i]
            replacement = line[i+1:].strip()
            dictionary['{@'+option+'}'] = replacement
        else:
            sk_file.seek(file_offset) # Move one line back
            break

    script = sk_file.read()

    # The following three lines are courtesy of https://stackoverflow.com/a/6117124
    rep = dict((re.escape(key), value) for key, value in dictionary.items())
    pattern = re.compile("|".join(rep.keys()))
    script = pattern.sub(lambda m: rep[re.escape(m.group(0))], script)

    ''' OLD WAY. TURNS OUT I NEEDED TO DO THE REPLACEMENT IN A SINGLE-PASS, AND THIS LOOP DOESN'T QUITE WORK
    for key, value in dictionary.items():
        script = script.replace(key, value)
    '''

    out_file.write(script)

    sk_file.close()
    out_file.close()

    print('Finished deobfuscating succesfully! Check the "deobf_{0}" file!'.format(fname))


run()
